#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MaxN = 100;
string tmp;
char lab[MaxN+2][MaxN+2];
int vis[MaxN+2][MaxN+2];
int g[28][28];
int n, m;
char c;

const int dx[] = {1, -1, 0, 0};
const int dy[] = {0, 0, 1, -1};


void init()
{
	memset(lab, 0, sizeof(lab));
	memset(vis, 0, sizeof(vis));
	memset(g, 255, sizeof(g));

	for (int i = 0; i <= n+1; i++) {
		lab[i][0] = lab[i][m+1] = '#';
	}

	for (int j = 0; j <= m+1; j++) {
		lab[0][j] = lab[n+1][j] = '#';
	}
}


void dfs(int y, int x)
{
	vis[y][x] = 1;
	if (lab[y][x] >= '@' && lab[y][x] <= '[') {
		if (lab[y][x] > c) {
			g[c-'@'][lab[y][x]-'@'] = (lab[y][x]-'A'+1) % 27;
			return;
		} else {
			g[c-'@'][lab[y][x]-'@'] = 0;
		}
	}
	if (lab[y][x] == '*') {
		g[c][27] = 0;
	}
	for(int t = 0; t < 4; t++) {
		int xx = x + dx[t];
		int yy = y + dy[t];
		if (lab[yy][xx] != '#' && !vis[yy][xx]) {
			dfs(yy, xx);
		}
	}
}


int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int test_number;
	cin >> test_number;
	for (int test_case = 0; test_case < test_number; test_case++) {
		cin >> m >> n;

		init();
		for (int i = 1; i <= n; i++) {
			cin >> tmp;
			for (int j = 1; j <= m; j++) {
				lab[i][j] = tmp[j-1];
				if (lab[i][j] == '*') {
					lab[i][j] = '[';
				}
			}
		}
		lab[1][1] = '@';

		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				if (lab[i][j] >= '@' && lab[i][j] <= 'Z') {
					memset(vis, 0, sizeof(vis));
					c = lab[i][j];
					dfs(i, j);
				}
			}
		}


		for (int k = 0; k < 28; k++) {
			for (int i = 0; i < 28; i++) {
				for (int j = 0; j < 28; j++) {
					if (g[i][k] != -1 && g[k][j] != -1) {
						if (g[i][j] == -1 || g[i][j] > g[i][k] + g[k][j]) {
							g[i][j] = g[i][k] + g[k][j];
						}
					}
				}
			}
		}

		cout << g[0][27] << endl;
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
